﻿using AD_MAUI.Model;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace AD_MAUI.ViewModel
{
    // TODO make sure not to notify change if not necessary!
    public class SongViewModel : INotifyPropertyChanged
    {
        private readonly Song song;

        public event PropertyChangedEventHandler? PropertyChanged;

        public string Title
        {
            get => song.Title;
            set
            {
                if (song.Title != value)
                {
                    song.Title = value;
                    OnPropertyChanged();
                }
            }
        }

        public int Duration
        {
            get => song.Duration;
            set
            {
                if (song.Duration != value)
                {
                    song.Duration = value;
                    OnPropertyChanged();
                }
            }
        }

        public SongViewModel(Song? song)
        {
            this.song = song ?? new();
        }

        protected virtual void OnPropertyChanged([CallerMemberName] string? propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

}
